const Benchmark = require('benchmark');
const bb = require('beautify-benchmark');

var map = {
  foo: 1
};
var fooKey = 'foo';
var barKey = 'bar';

new Benchmark.Suite()
  .on('cycle', (event) => {
    bb.add(event.target);
  })
  .on('complete', () => {
    bb.log();
  })
/*
  .add('.prop && ||', () => {
    for (var i = 1000; i--;) {
      var foo = map && map.foo || 0;
      var bar = map && map.bar || 0;
    }
  })
  .add('.prop ternary', () => {
    for (var i = 1000; i--;) {
      var foo = map && map.foo ? map.foo : 0;
      var bar = map && map.bar ? map.bar : 0;
    }
  })
  .add('.prop hasOwnProperty', () => {
    for (var i = 1000; i--;) {
      var foo = map && map.hasOwnProperty('foo') ? map.foo : 0;
      var bar = map && map.hasOwnProperty('bar') ? map.bar : 0;
    }
  })
*/
  .add('.prop typeof !== undefined', () => {
    for (var i = 1000; i--;) {
      var foo = map && typeof map.foo !== 'undefined' ? map.foo : 0;
      var bar = map && typeof map.bar !== 'undefined' ? map.bar : 0;
    }
  })
  .add('.prop typeof === number', () => {
    for (var i = 1000; i--;) {
      var foo = map && typeof map.foo === 'number' ? map.foo : 0;
      var bar = map && typeof map.bar === 'number' ? map.bar : 0;
    }
  })
/*
  .add('[key] && ||', () => {
    for (var i = 1000; i--;) {
      var foo = map && map[fooKey] || 0;
      var bar = map && map[barKey] || 0;
    }
  })
  .add('[key] ternary', () => {
    for (var i = 1000; i--;) {
      var foo = map && map[fooKey] ? map[fooKey] : 0;
      var bar = map && map[barKey] ? map[barKey] : 0;
    }
  })
  .add('[key] hasOwnProperty', () => {
    for (var i = 1000; i--;) {
      var foo = map && map.hasOwnProperty('foo') ? map[fooKey] : 0;
      var bar = map && map.hasOwnProperty('bar') ? map[barKey] : 0;
    }
  })
*/
  .add('[key] typeof !== undefined', () => {
    for (var i = 1000; i--;) {
      var foo = map && typeof map[fooKey] !== 'undefined' ? map[fooKey] : 0;
      var bar = map && typeof map[barKey] !== 'undefined' ? map[barKey] : 0;
    }
  })
  .add('[key] typeof === number', () => {
    for (var i = 1000; i--;) {
      var foo = map && typeof map[fooKey] === 'number' ? map[fooKey] : 0;
      var bar = map && typeof map[barKey] === 'number' ? map[barKey] : 0;
    }
  })
  .run({ 'async': true });  